#Dump all registrated services

from bioMoby import Client, ServiceQuery, ServiceArticle, ServiceSecondary

client=Client()

dsn=client.retrieveServiceNames()

f=file('resultats.html','w')

f.write("<html><head><title>Results</title></head><body>")

ddd=dsn.keys()
ddd.sort()

for serviceName in ddd:
	f.write("<a href=\"#"+serviceName+"\">"+serviceName+"</a><br/>")

for serviceName in ddd:
	sl=client.findService(ServiceQuery(serviceName=serviceName))
        
	if len(sl)>0:
		f.write("<br><HR><br>")
		f.write("<a name=\""+serviceName+"\"><H1>Name: " + serviceName+"</H1><br></a>")
		f.write("<b>Category: </b>" + sl[0].category+"<br/>")
		f.write("<b>Description: </b>" + sl[0].description+"<br/>")
		f.write("<b>URL:</b><a href=\""+sl[0].url+"\">"+sl[0].url+"</a><br/>")
		f.write("<b>Email:</b> <a href=\"mailto:"+sl[0].contact+"\">"+sl[0].contact+"</a><br/>")
		f.write("<br><HR></br>")
		f.write("<h3><b>Inputs:</b></h3>")
        
		for inp in sl[0].inputObjects:
			if inp.__class__  is ServiceArticle:
				f.write("<b>Article's name:</b>" + inp.name +"<br/>")
				f.write("<b>Object's type:</b>" + inp.type +"<br/>")
				for namespace in inp.namespaces:
					f.write("<b>Name space:</b>" + namespace +"<br/>")
			if inp.__class__ is dict:
				for key in inp.keys():
					f.write("<b>Collection's name:</b>" + key +"<br/>")
					listofArticles=inp[key]
					for article in listofArticles:
						f.write("<b>Article's name:</b>" + article.name +"<br/>")
						f.write("<b>Object's type:</b>" + article.type +"<br/>")
						for namespace in article.namespaces:
							f.write("<b>Name space:</b>"+namespace+"<br/>")
                    

		f.write("<br><HR></br>")
            
		f.write("<h3><b>Outputs:</b></h3>")
            
		for inp in sl[0].outputObjects:
			if inp.__class__  is ServiceArticle:
				f.write("<b>Article's name:</b>" + inp.name +"<br/>")
				f.write("<b>Object's type:</b>" + inp.type +"<br/>")
				for namespace in inp.namespaces:
					f.write("<b>name space:</b>" + namespace +"<br/>")
			if inp.__class__ is dict:
				for key in inp.keys():
					f.write("<b>Collection's name:</b>" + key +"<br/>")
					listofArticles=inp[key]
					for article in listofArticles:
						f.write("<b>Article's name:</b>" + article.name +"<br/>")
						f.write("<b>Object's type:</b>" + article.type +"<br/>")
						for namespace in article.namespaces:
							f.write("<b>Name space:</b>" + namespace +"<br/>")


		f.write("<br><HR><br>")
 
		f.write("<h3><b>Secondary</b></h3>")
           
		for sec in sl[0].secondaryArticles:
			f.write("Parameter name: "+sec.name+"<br/>")
			f.write("default: "+sec.default+"<br/>")
			f.write("min: "+sec.min+"<br/>")
			f.write("max: "+sec.max+"<br/>")
			f.write("enums: <br/>")
			for enum in sec.enums:
				f.write("value: "+enum+"<br/>")
f.write("</body></html>")
f.close()

