#!/bin/env python
#Clustalw wrapped into a cgi style webservice


def commandBuilder(queryData):
    commandName="clustalw"
    parameters=[]
    tempfiles=[]
    outputfiles=[]

    from bioMoby import Parameter 
    import random

    tfs='/tmp/tmp'+ `int(random.random()*1000000)`
    
    for datum in queryData:
        if datum.__class__ is Parameter:
            parameters.append("-"+datum.articleName+"="+datum.value)
        else:
            try:
                fp=file(tfs,"w")
                fp.write(datum.content)
                fp.close
                parameters.append("-infile="+tfs)
                tempfiles.append(tfs)
            except:
                pass
                
    tempfiles.append(tfs+".dnd")
    outputfiles.append(tfs+".aln")
            
    return (commandName, " type=p -align "+" ".join(parameters), tempfiles, outputfiles)
    
def ClustalFormatter(results):
    def ClustalFormatter(results):
    """Return the results in a MobyClustalAlnFormattedText object
    """
    from bioMoby import MobyClustalAlnFormattedText
    
    return [MobyClustalAlnFormattedText(content=results)]
    
def clustalw(mobyContent):
    from bioMoby import Dispatcher, LocalInvocator
    
    d=Dispatcher(mobyContent, LocalInvocator, commandBuilder, formatter=ClustalFormatter)
    
    return d.execute()
    
from ZSI import dispatch
dispatch.asCGI()
